<?php
/**
 * @file
 * popup window for isdn and anolog groups
 */
chdir("..");

include "./includes/variables.php";
include "./misc/database.php";
include("./misc/config_parameter.php");
$ba = new beroAri();
require_once ('./includes/lang.php');
require_once ("./includes/isgwtelnet.php");

$group = '"general"';
$query_comp = $ba->select("SELECT * FROM gsm");
while ($entry = $ba->fetch_array($query_comp)) {
    if ($entry['gr'] != $_GET['gr'])
        $group.=',' . '"' . $entry['gr'] . '"';
}
?>


<script>
    $("#gsmpop").validate({
        rules: {
            group: {
                required: true,
                specChar: true,
                checkBlank: true,
                compareName: [<?php echo $group; ?>]
            },
            'ports[]': {
                atLeastOnePort: true,
            }
        }
    });

    function hidec() {
        var configt = document.getElementById('configt');
        configt.style.display = "none";
    }
    function show_config() {
        var configt = document.getElementById('configt');
        if (configt.style.display == "none") {
            configt.style.display = "";
        } else {
            configt.style.display = "none";
        }
    }

</script>
<center>
<?php

function title0($ba, $gr) {
    $query = $ba->select("select distinct type from gsm where lif='0' union select distinct type from analog where lif='0' union select distinct type from isdn where lif='0' union select distinct type from cas where lif='0'");
    if (sqlite_num_rows($query) == 0) {
        $title = "<b>Li0()</b>";
    } else {
        while ($entry = $ba->fetch_array($query)) {
            $title = "<b>Li0(" . $entry['type'] . ")</b>";
        }
    }
    return $title;
}

//Ports von Line interface 0
function ports0($ba, $gr) {
    $query = $ba->select("select * from gsm where lif='0'");
    while ($entry = $ba->fetch_array($query)) {
        $type = split("-", $entry['type']);
        if ($entry['gr'] == $gr) {
            $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' checked value='" . $entry['port'] . "'></div>";
        } elseif ($entry['gr'] == 'NULL') {
            $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' value='" . $entry['port'] . "'></div>";
        } else {
            $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' checked disabled='true' value='" . $entry['port'] . "'></div>";
        }
    }
    return $tab;
}

function title1($ba, $gr) {
    $query = $ba->select("select distinct type from gsm where lif='1' union select distinct type from analog where lif='1' union select distinct type from isdn where lif='1' union select distinct type from cas where lif='1'");
    if (sqlite_num_rows($query) == 0) {
        $title = "<b>Li1()</b>";
    } else {
        while ($entry = $ba->fetch_array($query)) {
            $title = "<b>Li1(" . $entry['type'] . ")</b>";
        }
    }
    return $title;
}

//Ports von Line interface 1
function ports1($ba, $gr) {
    $query = $ba->select("select * from gsm where lif='1'");
    while ($entry = $ba->fetch_array($query)) {
        $type = split("-", $entry['type']);
        if ($entry['gr'] == $gr) {
            $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' checked value='" . $entry['port'] . "'></div>";
        } elseif ($entry['gr'] == 'NULL') {
            $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' value='" . $entry['port'] . "'></div>";
        } else {
            $tab .= "<div>Port " . $entry['port'] . "<input type='checkbox' name='ports[]' checked disabled='true' value='" . $entry['port'] . "'></div>";
        }
    }
    return $tab;
}

function chansel($ba, $gr) {
    if ($gr != "") {
        $query = $ba->select("select chansel from gsm where gr='" . $gr . "'");
        $ret = "<select name='chansel'>";
        while ($entry = $ba->fetch_array($query)) {
            ($entry['chansel'] == "standard") ? $ret.= "<option value='standard' selected>standard</option>" : $ret.= "<option value='standard'>standard</option>";
            ($entry['chansel'] == "random") ? $ret.= "<option value='random' selected>random</option>" : $ret.= "<option value='random'>random</option>";
            ($entry['chansel'] == "roundrobin") ? $ret.= "<option value='roundrobin' selected>roundrobin</option>" : $ret.= "<option value='roundrobin'>roundrobin</option>";
            $ret.="</select>";
            return $ret;
        }
    } else {
        return "<select name='chansel'>
			<option value='standard'>standard</option>
			<option value='random'>random</option>
			<option value='roundrobin'>roundrobin</option>
			</select>";
    }
}

function chansel_dir($ba, $gr) {
    $ret = "<select name='chansel_dir'>";
    if ($gr != "") {
        $query = $ba->select("select chansel_dir from gsm where gr='" . $gr . "'");
        while ($entry = $ba->fetch_array($query)) {
            ($entry['chansel_dir'] == "ascending") ? $ret.="<option value='ascending' selected>ascending</option>" : $ret.="<option value='ascending'>ascending</option>";
            ($entry['chansel_dir'] == "descending") ? $ret.="<option value='descending' selected>descending</option>" : $ret.="<option value='descending'>descending</option>";
            $ret.="</select>";
            return $ret;
        }
    } else {
        return "<select name='chansel_dir'>
			<option value='ascending'>ascending</option>
			<option value='descending'>descending</option>
			</select>";
    }
}

function getField($ba, $gr, $field) {
    if ($gr != "") {
        $query = $ba->select("select $field from gsm where gr='" . $gr . "'");
        while ($entry = $ba->fetch_array($query)) {
            return $entry[$field];
        }
    } else {
        return "";
    }
}

function showdefmc($config_values) {
    $isgw = new isgwtelnet();
    $result = $isgw->isgw_login();
    if ($result != false) {
        $dialplanc = $isgw->isgw_dialplanconfig();
        $zeilen = split("\n", $dialplanc);
        foreach ($zeilen as $zeile) {
            if (stripos($zeile, '[') === 0) {
                preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $zeile, $res);
                if (!in_array($res['name'], $config_values) && ($res['bez'] == "g" || $res['bez'] == "*"))
                    echo "<script>
							var extra_tooltip=document.getElementById('extra_tooltip');
							extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>" . DIALPLAN_OPTION_DIS . "<b>&nbsp;" . $res['name'] . "</b><br>" . DIALPLAN_VALUES_DIS . "<b>&nbsp;&lt;" . $res['val'] . "&gt;</b><br>Default:<b>&nbsp;".$res['def']."</b><br><i>" . htmlspecialchars ($res['desc'],ENT_QUOTES) . "</i></p><br>';
						</script>";
            }
        }
        $ba = new beroAri();
        $query = $ba->select("select config from gsm where gr='" . $_GET['gr'] . "' group by gr");
        while ($entry = $ba->fetch_array($query)) {
            $config = $entry['config'];
        }
        if ($config != "") {
            $configs = split(',', $config);
            foreach ($configs as $value) {
                $key = explode('=', $value, 2);
                if ($key[0] != "" && $key[1] != "" && !in_array($key[0], $config_values)) {
                    echo "<script>var addit_options=document.getElementById('addit_options');
							if (addit_options.innerHTML=='')
								addit_options.innerHTML='" . $key[0] . "=" . $key[1] . "';
							else
								addit_options.innerHTML=addit_options.innerHTML+'\\n" . $key[0] . "=" . $key[1] . "';</script>";
                } elseif ($key[0] != "" && $key[1] == "" && !in_array($key[0], $config_values)) {
                    echo "<script>var addit_options=document.getElementById('addit_options');
							if (addit_options.innerHTML=='')
								addit_options.innerHTML='" . $key[0] . "=';
							else
								addit_options.innerHTML=addit_options.innerHTML+'\\n" . $key[0] . "=';</script>";
                }
            }
        }
    }
}

function show_confadd($config_values) {
    $isgw = new isgwtelnet();
    $result = $isgw->isgw_login();
    if ($result != false) {

        $dialplanc = $isgw->isgw_dialplanconfig();
        $zeilen = split("\n", $dialplanc);
        foreach ($zeilen as $zeile) {
            if (stripos($zeile, '[') === 0) {
                preg_match("/\[(?<bez>.+)\]\[(?<name>.+)\][\s]*(?<desc>.+)[\s]*\<(?<val>.*)\>[\s]*'(?<def>.*)'/", $zeile, $res);
                if (!in_array($res['name'], $config_values) && ($res['bez'] == "g" || $res['bez'] == "*"))
                    echo "<script>
						var extra_tooltip=document.getElementById('extra_tooltip');
						extra_tooltip.innerHTML=extra_tooltip.innerHTML+'<p>" . DIALPLAN_OPTION_DIS . "<b>&nbsp;" . $res['name'] . "</b><br>" . DIALPLAN_VALUES_DIS . "<b>&nbsp;&lt;" . $res['val'] . "&gt;</b><br>Default:<b>&nbsp;".$res['def']."</b><br><i>" . htmlspecialchars ($res['desc'],ENT_QUOTES) . "</i></p><br>';
						var addit_options=document.getElementById('addit_options');
						if (addit_options.innerHTML=='')
							addit_options.innerHTML='" . $res['name'] . "=" . $res['def'] . "';
						else
							addit_options.innerHTML=addit_options.innerHTML+'\\n" . $res['name'] . "=" . $res['def'] . "';
					</script>";
            }
        }
    }
}

$config_values = array();

echo ("<form class='extensions_form' name='gsmpop' id='gsmpop' action='misc/gsm_submit.php' method='POST'>
			<table class='contenttoc'>
			<tr>
			<td><b>" . PSTN_NAME_DIS . ":</b>&nbsp;</td>
			<td>&nbsp;<input type='text' name='group' value='" . $_GET['gr'] . "' onmouseover=\"Tip('" . GSM_GROUP_NAME . "');\" onmouseout='UnTip();'></td>
			</tr>
			<tr>
			<td valign='top' style='padding-top:5px;'><b>" . PSTN_PORTS_DIS . ":</b>&nbsp;</td>
			<td style='width:170px !important;'>
			<div style='float:left;'>
                                <div>" . title0($ba, $_GET['gr']) . "</div>
                                <div>" . ports0($ba, $_GET['gr']) . "</div>
                            </div>
                            <div style='float:right;'>
                                <div>" . title1($ba, $_GET['gr']) . "</div>
                                <div>" . ports1($ba, $_GET['gr']) . "</div>
                            </div>
                            <div class='clear'/>
			</td>
			</tr>
                        <tr onmouseover=\"Tip('" . PSTN_CHANSEL . "');\" onmouseout='UnTip();'>
			<td><b>" . PSTN_CHANSEL_DIS . ":</b></td><td>" . chansel($ba, $_GET['gr']) . "</td>
			</tr>
			<tr>
			<td><b>" . PSTN_CHANSEL_DIR_DIS . ":</b></td><td>" . chansel_dir($ba, $_GET['gr']) . "</td>
			</tr>
			<tr>
			<td><b>" . PSTN_SMS_EXTENSION_DIS . ":</b></td>
			<td><input type='text' name='sms_extension' value='" . getField($ba, $_GET['gr'], 'sms_extension') . "'></td>
			</tr>
			<tr>
			<td><b>" . PSTN_EXTENSION_DIS . ":</b></td>
			<td><input type='text' name='extension' value='" . getField($ba, $_GET['gr'], 'extension') . "'></td>
			</tr>
			<tr>
			<td align='center' colspan='2'><a href='#' onclick='show_config();'>" . PSTN_MORE_DIS . "...</a></td>
			</tr>

			</table>
			
			<br/>
			<table class='contenttoc' id='configt'><tr><td colspan='2' align='center'><b>" . DIALPLAN_CONFIGURATION_DIS . "</b></td></tr>

				<tr>
					<td colspan='2'>&nbsp;</td>
				</tr>
				<tr onmouseover=\"Tip('" . ADDIT_OPTIONS . "')\" onmouseout='UnTip()'>
						<td colspan='2'><b>" . DIALPLAN_ADDITIONAL_CONFIG_DIS . "</b></td>
					</tr>
					<tr onmouseover=\"Tip('" . ADDIT_OPTIONS . "')\" onmouseout='UnTip()'>
						<td colspan='2'><textarea name='addit_options' id='addit_options' rows='4' style='width:305px;'></textarea></td>
					</tr>
					<tr>
						<td colspan='2'>
						<br>
						<b>" . DIALPLAN_ADDITIONAL_CONFIG_DOC_DIS . "</b>
						</td>
					</tr>
					<tr>
						<td colspan='2'>
						<p id='extra_tooltip' style='height: 150px; text-align:left; width:305px; overflow: auto; border: 1px solid #A31D26; background: none repeat scroll 0% 0% rgb(238, 238, 238); color: rgb(0, 0, 0);'>
						</td>
					</tr>
			</table>");
if (isset($_GET['gr'])) {
    showdefmc($config_values);
} else {
    show_confadd($config_values);
}
echo ("<br/>
			<input type='hidden' name='gr_upd' value='" . $_GET['gr'] . "'>
			<div class='center'><input name='submit' type='submit' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . GSM_SAVE . "');\" onmouseout='UnTip();'>
			 &nbsp;&nbsp;<input name='close' type='button' value='" . BUTTON_CLOSE . "' onclick='javascript:$(\"#dialog\").dialog(\"close\");' onmouseover=\"Tip('" . POPUPS_BUTTON_CLOSE . "');\" onmouseout='UnTip();'></div>
			</form>");
?>
</center>

